web_app/event/urls.py
from django.urls import path
from .views import CreateEvent, ListEvent, EventDetails, DeleteEvent, UpdateEvent

app_name = 'event'

urlpatterns = [
    path('create/', CreateEvent.as_view(), name='event-create'),
    path('list/', ListEvent.as_view(), name='event-list'),
    path('details/<uuid:pk>/', EventDetails.as_view(), name='event-details'),
    path('delete/<uuid:pk>/', DeleteEvent.as_view(), name='event-delete'),
    path('update/<pk>/', UpdateEvent.as_view(), name='event-update'),
]

web_app/user/urls.py
from django.urls import path, include
from .views import RegisterUserView, LoginUserView, ActivateView, AccountView, DeleteAccount, UserUpdatePassword
from django.contrib.auth.views import LogoutView

app_name = 'user'

urlpatterns = [
    path('register/', RegisterUserView.as_view(), name='register'),
    path('login/', LoginUserView.as_view(), name='login'),
    path('logout/', LogoutView.as_view(), name='logout'),
    path('account/', AccountView.as_view(), name='account'),
    path('account/password/<pk>', UserUpdatePassword.as_view(), name='account-password'),
    path('account/delete/<pk>', DeleteAccount.as_view(), name='account-delete'),
    path('confirm-account/<token>/', ActivateView.as_view(), name='confirm-account'),
]

web_app/event/models.py
from uuid import uuid4
from django.db import models
from django.urls import reverse
from django.utils import timezone

from user.models import User


class Event(models.Model):
    id = models.UUIDField(
        primary_key=True,
        default=uuid4,
    )
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    name = models.CharField(max_length=100, unique=False, null=False)
    event_date = models.DateField(unique=False, null=False, default=timezone.now)
    event_time = models.TimeField(unique=False, null=False, default=timezone.now)
    annually = models.BooleanField(default=True, null=False)
    place = models.CharField(max_length=100, unique=False, null=True)
    description = models.CharField(max_length=250, null=True)

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse('event-details', kwargs={
            'pk': self.pk
        })

    class Meta:
        ordering = ['event_date']

web_app/event/forms.py
from django.forms import ModelForm, DateTimeInput
from event.models import Event


class EventCreateForm(ModelForm):
    class Meta:
        model = Event
        exclude = ['user']
        fields = [
            'name',
            'event_date',
            'event_time',
            'place',
            'description',
            'annually'
        ]
        widgets = {
            'event_date': DateTimeInput(attrs={'type': 'date'}),
            'event_time': DateTimeInput(attrs={'type': 'time'}),
        }

web_app/event/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.exceptions import PermissionDenied
from django.urls import reverse_lazy
from django.views import View
from django.views.generic import CreateView, ListView, DetailView, DeleteView, UpdateView

from event.forms import EventCreateForm
from event.models import Event
from user.models import User


class CreateEvent(LoginRequiredMixin, CreateView):
    model = Event
    form_class = EventCreateForm
    template_name = 'event/create_event.html'
    success_url = reverse_lazy('event:event-list')

    def form_valid(self, form):
        event = form.save(commit=False)
        event.user = User.objects.get(pk=self.request.user.pk)
        return super(CreateEvent, self).form_valid(form)


class ListEvent(LoginRequiredMixin, ListView):
    model = Event
    template_name = 'event/list_event.html'
    paginate_by = 5

    def get_queryset(self):
        queryset = super(ListEvent, self).get_queryset()
        return queryset.filter(user__pk=self.request.user.pk).order_by('event_date')


class EventDetails(LoginRequiredMixin, DetailView):
    model = Event
    template_name = 'event/details_event.html'

    def get_object(self, queryset=None):
        event_pk = self.kwargs.get('pk', '')
        event_obj = Event.objects.filter(pk=event_pk).get()
        if event_obj.user.pk != self.request.user.pk:
            raise PermissionDenied()
        return super().get_object(queryset)


class DeleteEvent(LoginRequiredMixin, DeleteView):
    model = Event
    success_url = reverse_lazy('event:event-list')

    def get_object(self, queryset=None):
        event_pk = self.kwargs.get('pk', '')
        event_obj = Event.objects.filter(pk=event_pk).get()
        if event_obj.user.pk != self.request.user.pk:
            raise PermissionDenied()
        return super().get_object(queryset)


class UpdateEvent(LoginRequiredMixin, UpdateView):
    model = Event
    success_url = reverse_lazy('event:event-list')
    form_class = EventCreateForm
    template_name = 'event/update_event.html'

    def form_valid(self, form):
        event = form.save(commit=False)
        event.user = User.objects.get(pk=self.request.user.pk)
        return super(UpdateEvent, self).form_valid(form)

    def get_object(self, queryset=None):
        event_pk = self.kwargs.get('pk', '')
        event_obj = Event.objects.filter(pk=event_pk).get()
        if event_obj.user.pk != self.request.user.pk:
            raise PermissionDenied()
        return super().get_object(queryset)

web_app/event/templates/event/create_event.html
{% extends "base.html" %}

{% block content %}
    <div style="text-align:center; padding-left: 35%; padding-right: 35%; padding-top: 3%">
        <form method="post" action="{% url 'event:event-create' %}">
            {% csrf_token %}
            {{ form.name.label_tag }}
            {{ form.name }}
            {{ form.event_date.label_tag }}
            {{ form.event_date }}
            {{ form.event_time.label_tag }}
            {{ form.event_time }}
            {{ form.place.label_tag }}
            {{ form.place }}
            {{ form.description.label_tag }}
            {{ form.description }}
            {# HACK - Checkbox created not dymanic because this django #}
            {# version product label incorrect for checkbox for some web browsers #}
            <p style="text-align: center">
                <label>
                    <input type="checkbox" checked="checked" name="annually" id="id_annually"/>
                    <span>{{ form.annually.label_tag }}</span>
                </label>
            </p>
            <div style="padding: 3%">
                <button class="waves-effect waves-light btn">Create</button>
            </div>
        </form>
    </div>
{% endblock %}

web_app/event/templates/event/details_event.html
{% extends "base.html" %}

{% block content %}
    <div style="padding: 1% 10% 0; text-align: center">
        <h3>{{ object.name }}</h3>
        <span style="display:block; width:100%; border-top: 1px solid; color: grey"></span>
    </div>
    <div style="padding: 1% 25% 5%; text-align: center">
        <table class="responsive-table">
            <thead>
            </thead>
            <tbody>
            <tr>
                <td style="text-align:center">
                    <p class="link-decorator" style="cursor: text">Date</p>
                </td>
                <td style="text-align:center">
                    <p class="link-decorator" style="cursor: text">{{ object.event_date }}</p>
                </td>
            </tr>
            <tr>
                <td style="text-align:center">
                    <p class="link-decorator" style="cursor: text">Time</p>
                </td>
                <td style="text-align:center">
                    <p class="link-decorator">{{ object.event_time }}</p>
                </td>
            </tr>
            <tr>
                <td style="text-align:center">
                    <p class="link-decorator">Annually</p>
                </td>
                <td style="text-align:center">
                    <p class="link-decorator" style="cursor: text">{{ object.annually }}</p>
                </td>
            </tr>
            <tr>
                <td style="text-align:center">
                    <p class="link-decorator" style="cursor: text">Place</p>
                </td>
                <td style="text-align:center">
                    <p class="link-decorator" style="cursor: text">{{ object.place }}</p>
                </td>
            </tr>
            <tr>
                <td style="text-align:center">
                    <p class="link-decorator" style="cursor: text">Description</p>
                </td>
                <td style="text-align:center; word-wrap: break-word">
                    <p class="link-decorator" style="cursor: text">{{ object.description }}</p>
                </td>
            </tr>
            </tbody>
        </table>
        <div style="padding: 3%">
            <a class="waves-effect waves-light btn" href="{% url 'event:event-update' object.pk %}">Update</a>
            <a class="waves-effect waves-light btn" href="{% url 'event:event-delete' object.pk %}">Delete</a>
        </div>
    </div>

{% endblock %}

web_app/event/templates/event/event_confirm_delete.html
{% extends "base.html" %}

{% block content %}
    <div style="padding: 10% 25% 5%; text-align: center">
        <form method="post" action="{% url 'event:event-delete' object.pk %}">
            {% csrf_token %}
            <h5 style="color: grey">Are you sure you want to delete "{{ object }}"?</h5>
            <div style="padding: 3%">
                <button class="waves-effect waves-light btn">Delete</button>
            </div>
        </form>
    </div>
{% endblock %}

web_app/event/templates/event/list_event.html
{% extends "base.html" %}
{% block content %}
    <div style="padding: 3% 10% 1%;">
        <table class="responsive-table">
            <thead>
            <tr>
                <th style="text-align:center">Name</th>
                <th style="text-align:center">Date</th>
                <th style="text-align:center">Place</th>
                <th style="text-align:center">Description</th>
                <th style="text-align:center">Annually</th>
            </tr>
            </thead>
            <tbody>
            {% for object in object_list %}
                <tr>
                    <td style="text-align:center; ">
                        <a class="link-decorator" href="{% url 'event:event-details' object.pk %}">
                            {{ object.name }}
                        </a>
                    </td>
                    <td style="text-align:center">
                        <a class="link-decorator" href="{% url 'event:event-details' object.pk %}">
                            {{ object.event_date }}
                        </a>
                    </td>
                    <td style="text-align:center">
                        <a class="link-decorator" href="{% url 'event:event-details' object.pk %}">
                            {{ object.place }}
                        </a>
                    </td>
                    <td style="text-align:center">
                        <a class="link-decorator" href="{% url 'event:event-details' object.pk %}">
                            {{ object.description }}
                        </a>
                    </td>
                    <td style="text-align:center">
                        <a class="link-decorator" href="{% url 'event:event-details' object.pk %}">
                            {{ object.annually }}
                        </a>
                    </td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    </div>

    <div class="pagination" style="padding: 1% 10% 5%;">
        <ul class="pagination">
            {% if page_obj.has_previous %}
                <li><a class="waves-effect" href="?page=1"><i class="material-icons">chevron_left</i>
                    <i class="material-icons">chevron_left</i></a></li>
                <li><a class="waves-effect" href="?page={{ page_obj.previous_page_number }}"><i
                        class="material-icons">chevron_left</i></a></li>
                {% if page_obj.number > 2 %}
                    <li class="waves-effect"><a
                            href="?page={{ page_obj.previous_page_number|add:"-1" }}">{{ page_obj.previous_page_number|add:"-1" }}</a></li>
                {% endif %}
                <li class="waves-effect"><a
                        href="?page={{ page_obj.previous_page_number }}">{{ page_obj.previous_page_number }}</a></li>
            {% endif %}
            <li class="active"><a href="?page={{ page_obj.number }}">{{ page_obj.number }}</a></li>
            {% if page_obj.has_next %}
                <li class="waves-effect"><a
                        href="?page={{ page_obj.next_page_number }}">{{ page_obj.next_page_number }}</a></li>
                {% if page_obj.next_page_number|add:"1" <= page_obj.paginator.num_pages %}
                    <li class="waves-effect"><a
                            href="?page={{ page_obj.next_page_number|add:"1" }}">{{ page_obj.next_page_number|add:"1" }}</a></li>
                {% endif %}
                <li><a class="waves-effect" href="?page={{ page_obj.next_page_number }}"><i class="material-icons">chevron_right</i></a>
                </li>
                <li><a class="waves-effect" href="?page={{ page_obj.paginator.num_pages }}"><i class="material-icons">chevron_right</i><i
                        class="material-icons">chevron_right</i></a></li>
            {% endif %}
        </ul>
    </div>

{% endblock %}

web_app/event/templates/event/update_event.html
{% extends "base.html" %}

{% block content %}
    <div style="text-align:center; padding-left: 35%; padding-right: 35%; padding-top: 3%">
        <form method="post">
            {#             action="{% url 'event:event-update' %}"#}
            {% csrf_token %}
            {{ form.name.label_tag }}
            {{ form.name }}
            {{ form.event_date.label_tag }}
            {{ form.event_date }}
            {{ form.event_time.label_tag }}
            {{ form.event_time }}
            {{ form.place.label_tag }}
            {{ form.place }}
            {{ form.description.label_tag }}
            {{ form.description }}
            {# HACK - Checkbox created not dymanic because this django #}
            {# version product label incorrect for checkbox for some web browsers #}
            <p style="text-align: center">
                {% if form.annually is True %}
                    <label>
                        <input type="checkbox" checked="checked" name="annually" id="id_annually"/>
                        <span>{{ form.annually.label_tag }}</span>
                    </label>
                {% else %}
                    <label>
                        <input type="checkbox" name="annually" id="id_annually"/>
                        <span>{{ form.annually.label_tag }}</span>
                    </label>
                {% endif %}
            </p>
            <div style="padding: 3%">
                <button class="waves-effect waves-light btn">Update</button>
            </div>
        </form>
    </div>
{% endblock %}